/**
 * 
 */
package com.flkr.gametest01;

import org.anddev.andengine.entity.sprite.AnimatedSprite;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.opengl.texture.region.TiledTextureRegion;
import org.anddev.andengine.opengl.vertex.RectangleVertexBuffer;

import android.view.MotionEvent;

import com.flkr.gametest01.events.SpriteEventConstants;
import com.flkr.gametest01.events.SpriteEvent;
import com.flkr.gametest01.events.SpriteEventHandler;

/**
 * @author evan
 *
 */
public class TouchSprite extends AnimatedSprite {

	
	long mDownTimeMilliseconds = 0;
	boolean mEnabled = true;
	boolean isValid = true;		// will be set by handler when destroy is needed
	
	private SpriteEventHandler mSpriteEventHandler;

	//---------- GETTERS/SETTERS ---------- 

	public SpriteEventHandler getSpriteEventHandler() {
		return mSpriteEventHandler;
	}

	public void setSpriteEventHandler(SpriteEventHandler mSpriteEventHandler) {
		this.mSpriteEventHandler = mSpriteEventHandler;
	}

	
	/**
	 * @param pX
	 * @param pY
	 * @param pTextureRegion
	 */
	public TouchSprite(float pX, float pY, TiledTextureRegion pTextureRegion) {
		super(pX, pY, (TiledTextureRegion) pTextureRegion);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param pX
	 * @param pY
	 * @param pTextureRegion
	 * @param pRectangleVertexBuffer
	 */
	public TouchSprite(float pX, float pY, TiledTextureRegion pTextureRegion,
			RectangleVertexBuffer pRectangleVertexBuffer) {
		super(pX, pY, pTextureRegion, pRectangleVertexBuffer);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param pX
	 * @param pY
	 * @param pWidth
	 * @param pHeight
	 * @param pTextureRegion
	 */
	public TouchSprite(float pX, float pY, float pWidth, float pHeight,
			TiledTextureRegion pTextureRegion) {
		super(pX, pY, pWidth, pHeight, pTextureRegion);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param pX
	 * @param pY
	 * @param pWidth
	 * @param pHeight
	 * @param pTextureRegion
	 * @param pRectangleVertexBuffer
	 */
	public TouchSprite(float pX, float pY, float pWidth, float pHeight,
			TiledTextureRegion pTextureRegion,
			RectangleVertexBuffer pRectangleVertexBuffer) {
		super(pX, pY, pWidth, pHeight, pTextureRegion, pRectangleVertexBuffer);
		// TODO Auto-generated constructor stub
	}

	@Override
	protected void onManagedUpdate(float pSecondsElapsed) {
		// TODO Auto-generated method stub
		super.onManagedUpdate(pSecondsElapsed);
	}

	@Override
	public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY)
	{
		boolean result = false; 
		switch (pSceneTouchEvent.getAction())
		{
		case MotionEvent.ACTION_DOWN:
			this.mRed = 1.0f;
			this.mGreen = 0;
			this.mBlue = 0;
			this.mAlpha = 0.5f;
						
			return this.mSpriteEventHandler.spriteEvent(new SpriteEvent(this, SpriteEventConstants.SPRITE_CLICKED, ""));
			
		case MotionEvent.ACTION_UP:
		case MotionEvent.ACTION_CANCEL:
			this.mRed = 1.0f;
			this.mGreen =1.0f;
			this.mBlue = 1.0f;
			this.mAlpha = 1.0f;
			result = true;
		default: result = false;
		}
		
		return result;
	}
	
	

}
